package com.zipcodewilmington.phonebook;

import org.junit.Assert;
import org.junit.Test;
import java.util.ArrayList;

public class PhoneBookTest
{
    @Test
    public void test01(){
        //GIVEN
        PhoneBook phonebook = new PhoneBook();
        boolean expect = false;
        boolean actual = true;

        //WHEN
        actual = phonebook.hasEntry("Jonathan");

        //RESULT
        Assert.assertEquals(expect, actual);
    }

    @Test
    public void test02(){
        //GIVEN
        PhoneBook phonebook = new PhoneBook();
        ArrayList<String> numbers = new ArrayList<>();
        numbers.add("12893454032");
        numbers.add("44056923094");
        boolean expect = true;
        boolean actual = false;

        //WHEN
        phonebook.addEntry("Jonathan", numbers);
        actual = phonebook.hasEntry("Jonathan");

        //RESULT
        Assert.assertEquals(expect, actual);
    }

    @Test
    public void test03(){
        //GIVEN
        PhoneBook phonebook = new PhoneBook();
        ArrayList<String> numbers = new ArrayList<>();
        numbers.add("12893454032");
        numbers.add("44056923094");
        String expect = "12893454032 44056923094";
        String actual = "";

        //WHEN
        phonebook.addEntry("Jonathan", numbers);
        actual = phonebook.lookUp("Jonathan");

        //RESULT
        Assert.assertEquals(expect, actual);
    }

    @Test
    public void test04(){
        //GIVEN
        PhoneBook phonebook = new PhoneBook();
        ArrayList<String> numbers = new ArrayList<>();
        numbers.add("12893454032");
        numbers.add("44056923094");
        boolean expect = false;
        boolean actual = true;

        //WHEN
        phonebook.addEntry("Jonathan", numbers);
        phonebook.remove("Jonathan");
        actual = phonebook.hasEntry("Jonathan");

        //RESULT
        Assert.assertEquals(expect, actual);
    }

    @Test
    public void test05(){
        //GIVEN
        PhoneBook phonebook = new PhoneBook();
        ArrayList<String> numbers = new ArrayList<>();
        numbers.add("12893454032");
        numbers.add("44056923094");
        String expected = "Jonathan";
        String actual = "";

        //WHEN
        phonebook.addEntry("Jonathan", numbers);
        actual = phonebook.reverseLookUp("12893454032");

        //RESULT
        Assert.assertEquals(expected, actual);
    }

    @Test
    public void test06() {
        //GIVEN
        PhoneBook phonebook = new PhoneBook();
        String[] names = {"Katie","Jonathan","Robby"};
        ArrayList<String> expect = new ArrayList<>();
        ArrayList<String> numbers = new ArrayList<>();
        numbers.add("1(302) 867-5309");
        numbers.add("1(302) 867-5309");
        expect.add("Jonathan 1(302) 867-5309 1(302) 867-5309");
        expect.add("Katie 1(302) 867-5309 1(302) 867-5309");
        expect.add("Robby 1(302) 867-5309 1(302) 867-5309");

        ArrayList<String> actual = new ArrayList<>();

        //WHEN
        for(int i = 0; i < names.length; i ++){
            phonebook.addEntry(names[i], numbers);
        }
        phonebook.printAlpha();
        actual = phonebook.getAlphatizedArray();

        //RESULT
        Assert.assertEquals(expect, actual);
    }
}
